/*!
        @file    $Id: doxygen.h #$

        @brief

        @author  Shinji Motoki  (smotoki)
                 $LastChangedBy: namekawa $

        @date    $LastChangedDate:: 2017-03-15 13:58:54 #$

        @version $LastChangedRevision: 1597 $
*/

#ifndef DOXYGEN_INCLUDED
#define DOXYGEN_INCLUDED

/**
   \mainpage Lattice QCD common code development Project
   \section intro [Introduction]
    Bridge++ is a code set for performing calculations in lattice QCD on linux workstations, and  \n
    supercomputers using "C/C++" standard language with MPI.
    \n

   \section environment [Environment]
        - Target platforms are listed in Makefile.
        - For confirmation on each environment, see Bridge++ wiki.
          https://www.bridge-hpc.org/
        \n
   \section install [Install]
        - See 'First Step Guide' on Bridge++ wiki.
    \n

   \section author [Authors]
   \subsection project_member Project Member
   Shinya    Aoki      (Kyoto Univ.)\n
   Tatsumi   Aoyama    (Nagoya Univ.)\n
   Kazuyuki  Kanaya    (Univ. of Tsukuba)\n
   Hideo     Matsufuru (KEK)\n
   Takaya    Miyamoto  (Kyoto Univ.)\n
   Yusuke    Namekawa  (Univ. of Tsukuba)\n
   Hidekatsu Nemura    (Univ. of Tsukuba)\n
   Yusuke    Taniguchi (Univ. of Tsukuba)\n
   Naoya     Ukita     (Univ. of Tsukuba)\n

   \subsection contributer Contributer
   Takumi    Doi       (RIKEN)\n
   Guido     Cossu     (KEK)\n
   Shoji     Hashimoto (KEK)\n
   Noriyoshi Ishii     (Osaka Univ.)\n
   Ken-ichi  Ishikawa  (Hiroshima Univ.)\n
   Issaku    Kanamori  (Hiroshima Univ.)\n
   Takashi   Kaneko    (KEK)\n
   Yoshinobu Kuramashi (Univ. of Tsukuba)\n
   Kenji     Ogawa     (National Chiao Tung University)\n
   Kenji     Sasaki    (Univ. of Tsukuba)\n
   Tomoteru  Yoshie    (Univ. of Tsukuba)\n

   \subsection former_member Former Member
   Shinji    Motoki    (KEK)\n
   Satoru    Ueda      (KEK)\n
   Jun-Ichi  Noaki     (KEK)\n
   Hana      Saito     (Univ. of Tsukuba)\n

   \section history [History]
    - 2017/03/15    Version 1.4 Release.
    - 2015/10/08    Version 1.3 Release.
    - 2014/09/17    Version 1.2 Release.
    - 2013/07/22    Version 1.1 Release.
    - 2012/07/25    Version 1.0 Release.
    - \date 2009-2017
 */
#endif //DOXYGEN_H


//   \section reference Reference
//    - [ref]
//    - [ref]
