/*!
        @file    $Id:: gaugeFixing_None.cpp #$

        @brief

        @author  Yusuke Namekawa (namekawa)
                 $LastChangedBy: aoym $

        @date    $LastChangedDate:: 2017-02-24 00:49:46 #$

        @version $LastChangedRevision: 1561 $
*/

#include "gaugeFixing_None.h"


using std::valarray;

#ifdef USE_FACTORY
namespace {
  GaugeFixing *create_object()
  {
    return new GaugeFixing_None();
  }


  bool init = GaugeFixing::Factory::Register("None", create_object);
}
#endif


const std::string GaugeFixing_None::class_name = "GaugeFixing_None";

//====================================================================
void GaugeFixing_None::set_parameters(const Parameters& params)
{
  //- No parameters are set.
}


//====================================================================
void GaugeFixing_None::set_parameters(const int Niter, const int Nnaive,
                                      const int Nmeas, const int Nreset,
                                      const double Enorm, const double wp)
{
  //- No parameters are set.
}


//====================================================================
void GaugeFixing_None::fix(Field_G& Ufix, const Field_G& Uorg)
{
  copy(Ufix, Uorg);  // do nothing for gauge fixing, just copy input.
}


//====================================================================
//============================================================END=====
